<template>
  <v-container>
    <v-data-iterator
      v-if="currentlyDataFolder.length !== 0"
      :items="currentlyDataFolder"
      disable-pagination
      hide-default-footer
      :loading="driveLoading"
    >
      <!-- HEADER FILE -->
      <template v-slot:header>
        <v-row>
          <v-col> <span class="typeStyle caption font-weight-medium">Pastas:</span></v-col>
        </v-row>
      </template>

      <!-- Begin Card Style -->
      <template v-slot:default="props">
        <v-row>
          <v-col v-for="(item, index) in props.items" :key="index" cols="2">
            <v-hover v-slot:default="{ hover }">
              <v-card class="v-card--hover" outlined>
                <!-- Folder img -->
                <v-card-title
                  class="subtitle-1 font-weight-bold justify-center"
                  @click="toChildren(item)"
                >
                  <v-col class="space" cols="12" align="center">
                    <!-- short name's directory -->
                    <v-icon :class="hover ? 'iconCard test--text' : 'iconCard drive--text'" x-large>
                      mdi-folder
                    </v-icon>
                  </v-col>
                  <v-tooltip bottom v-if="item.name.length >= 25" color="primary">
                    <template v-slot:activator="{ on }">
                      <span v-on="on"> {{ item.name.substring(0, 22) }}...</span>
                    </template>
                    <span>{{ item.name }}</span>
                  </v-tooltip>
                  <span v-if="item.name.length < 25">{{ item.name }}</span>
                </v-card-title>
                <!-- content hover -->
                <v-card-subtitle class="" v-if="!hover">
                  <v-icon class="iconOptionsCard white--text" small>mdi-pencil-outline</v-icon>
                </v-card-subtitle>
                <v-card-subtitle align="end" v-if="hover">
                  <!-- rename button -->
                  <v-tooltip bottom color="primary">
                    <template v-slot:activator="{ on }">
                      <v-icon
                        class="iconOptionsCard secondary--text"
                        small
                        v-on="on"
                        @click="rename(item)"
                        >mdi-pencil-outline</v-icon
                      >
                    </template>
                    <span>Renomear</span>
                  </v-tooltip>

                  <!-- delete button -->
                  <v-tooltip bottom color="primary">
                    <template v-slot:activator="{ on }">
                      <v-icon
                        class="iconOptionsCard secondary--text"
                        small
                        v-on="on"
                        @click="nameOfItem(item)"
                        >mdi-delete-outline</v-icon
                      >
                    </template>
                    <span>Deletar</span>
                  </v-tooltip>

                  <!-- end icons-->
                </v-card-subtitle>
                <!-- end content hover -->
              </v-card>
            </v-hover>
          </v-col>
        </v-row>
      </template>
      <!-- End Card Style -->
    </v-data-iterator>
  </v-container>
</template>

<script>
export default {
  props: {
    // eslint-disable-next-line vue/require-default-prop
    currentlyDataFolder: {
      type: Array,
    },
    driveLoading: {
      type: Boolean,
    },
  },
  data: () => ({}),
  methods: {
    toChildren(item) {
      this.$emit('folder', item)
    },
    nameOfItem(item) {
      this.$emit('itemToDelete', item)
    },
    rename(item) {
      this.$emit('itemToRename', item)
    },
  },
}
</script>

<style>
.iconTitle {
  padding-right: 15px;
  padding-bottom: 5px;
}
.typeStyle {
  padding-left: 15px;
}
.nameDirectory {
  margin-bottom: 12px;
}

.iconCard {
  transform: scale(1.3);
}
.iconOptionsCard {
  padding-left: 3px;
  padding-right: 3px;
}
</style>
